/*
 * Encender y apagar LED desde el navegador
 * Versión de texto
 * xsetaseta@gmail.com
 * http://seta43.blogspot.com/
 */


#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>
#include <ESP8266mDNS.h>

#ifndef STASSID
#define STASSID "router"
#define STAPSK  "contraseña"
#endif


#define LED_D0 16
#define LED_D1 5
#define LED_D2 4
#define LED_D3 0

const char* ssid = STASSID;
const char* password = STAPSK;

ESP8266WebServer server(80);


#define MAXmibuffer2  1000
char mibuffer2[MAXmibuffer2 + 1];  //ajustar al tamaÃ±o de la

bool F_led0;
bool F_led1;
bool F_led2;
bool F_led3;

//PROGMEM
char  Iniciohtml[] = "<!DOCTYPE HTML>\r\n <html><TITLE>SERVER WEB NodeMCU - ESP8266 </TITLE> <h1><b>Seta43_ESP8266_NodeMCU </b><a href=\"./\">__ACTUALIZAR__</a></h1><hr>";
char  Cuerpohtml[] = "<h1> <a href=\"./led0_on\">LED0_ON</a> ---------- <a href=\"./led0_off\">LED0_OFF</a> <hr> <a href=\"./led1_on\">LED1_ON</a> ---------- <a href=\"./led1_off\">LED1_OFF</a> <hr> <a href=\"./led2_on\">LED2_ON</a> ---------- <a href=\"./led2_off\">LED2_OFF</a> <hr> <a href=\"./led3_on\">LED3_ON</a> ---------- <a href=\"./led3_off\">LED3_OFF</a> <hr> </h1> ";
char  Finhtml[] = " <hr> <br> xsetaseta@gmail.com </html>";


void handleRoot()
{
  int z;
  strcpy(mibuffer2, Iniciohtml);
  strcat(mibuffer2, Cuerpohtml);
  if (F_led0 == 1)
    strcat(mibuffer2, "<h1> <font color=\"#990000\"> LED0=1 </font> </h1>");
  else
    strcat(mibuffer2, "<h1> <font color=\"#000000\"> LED0=0 </font> </h1>");

  if (F_led1 == 1)
    strcat(mibuffer2, "<h1> <font color=\"#990000\"> LED1=1 </font> </h1>");
  else
    strcat(mibuffer2, "<h1> <font color=\"#000000\"> LED1=0 </font> </h1>");

  if (F_led2 == 1)
    strcat(mibuffer2, "<h1> <font color=\"#990000\"> LED2=1 </font> </h1>");
  else
    strcat(mibuffer2, "<h1> <font color=\"#000000\"> LED2=0 </font> </h1>");

  if (F_led3 == 1)
    strcat(mibuffer2, "<h1> <font color=\"#990000\"> LED3=1 </font> </h1>");
  else
    strcat(mibuffer2, "<h1> <font color=\"#000000\"> LED3=0 </font> </h1>");


  strcat(mibuffer2, Finhtml);
  z = strlen(mibuffer2);
  server.send(z, "text/html", mibuffer2 );
}

void f_led0_off()  {  F_led0 = 0;  handleRoot();  digitalWrite(LED_D0, LOW); }
void f_led0_on()   {  F_led0 = 1;  handleRoot();  digitalWrite(LED_D0, HIGH);}

void f_led1_off()  {  F_led1 = 0;  handleRoot();  digitalWrite(LED_D1, LOW); }
void f_led1_on()   {  F_led1 = 1;  handleRoot();  digitalWrite(LED_D1, HIGH);}

void f_led2_off()  {  F_led2 = 0;  handleRoot();  digitalWrite(LED_D2, LOW); }
void f_led2_on()   {  F_led2 = 1;  handleRoot();  digitalWrite(LED_D2, HIGH);}

void f_led3_off()  {  F_led3 = 0;  handleRoot();  digitalWrite(LED_D3, LOW); }
void f_led3_on()   {  F_led3 = 1;  handleRoot();  digitalWrite(LED_D3, HIGH);}    



void handleNotFound()
{
  String message = "File Not Found\n\n";
  server.send(404, "text/plain", message);
}

void setup(void) {

  pinMode(LED_D0, OUTPUT);
  pinMode(LED_D1, OUTPUT);
  pinMode(LED_D2, OUTPUT);
  pinMode(LED_D3, OUTPUT);

  digitalWrite(LED_D0, LOW);
  digitalWrite(LED_D1, LOW);
  digitalWrite(LED_D2, LOW);
  digitalWrite(LED_D3, LOW);
  

  Serial.begin(115200);
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  Serial.println("COMIENZA");


  // Wait for connection
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.print("Connected to ");
  Serial.println(ssid);
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());


  if (MDNS.begin("esp8266")) {
    Serial.println("MDNS responder started");
  }

  server.on("/", handleRoot);
  server.on("/led0_on", f_led0_on);
  server.on("/led0_off", f_led0_off);

  server.on("/led1_on", f_led1_on);
  server.on("/led1_off", f_led1_off);

  server.on("/led2_on", f_led2_on);
  server.on("/led2_off", f_led2_off);

  server.on("/led3_on", f_led3_on);
  server.on("/led3_off", f_led3_off);

  server.on("/ok", []() {    server.send(200, "text/plain", "TRABAJA BIEN");  });

  server.onNotFound(handleNotFound);

  server.begin();
  Serial.println("HTTP server started");
}

void loop(void) 
{
  server.handleClient();
  MDNS.update();
}
